Subject: Re: bug#77028: 30.1; Ode to Po Lu

From: Yuan Fu <[email-masked]>
Date: Sun, 16 Mar 2025 23:54:49 -0700

> On Mar 15, 2025, at 3:16 AM, Yuchen Guo via Bug reports for GNU Emacs, the Swiss army knife of text editors <[email-masked]> wrote:
> 
> My life is based on computing.  For me, computing means using Emacs.
> 
> Emacs has been kind to me.
> 
> Since 2023, every letter, punctuation and every CJK Character
> sublimated into their crisp existence in Emacs.
> 
> I know, this is due to your pure GTK porting effort.
> 
> You changed my computing experience.  You changed my life.
> 
> +++++++++
> 
> I depend on Org Agenda mode for scheduling my day.  Necessarily
> on-the-go.
> 
> Common sense dictates that, smartphones are better at this than
> devices with keyboards.
> 
> So I was using Termux and their packaged TUI Emacs.
> 
> I was satisfied, but every time I launch Emacs in Termux, the CJK
> characters, forcibly stretched in their terminal cells, cry out their
> pain.
> 
> +++++++++
> 
> But yesterday, I discovered your Android port of Emacs.
> 
> I dropped everything I was doing, backed up dotfiles, uninstalled
> Termux from F-Droid, and installed your version of Termux, then Emacs.
> 
> With anticipation, I cloned my Org Agenda repo and launched Android
> Emacs.
> 
> No soft keyboard with modifier keys.
> 
> CJK Characters displayed as boxes.
> 
> Even volume keys are not binded, whereas in Termux <volume-up> is
> binded to Alt and <volume-down> is binded to Control.
> 
> Obnoxious menu bars and tool bars occupy valuable screen real estate.
> 
> This is all so foreign to me.  In Termux everything worked.
> 
> What do I do?  Did I make a mistake?
> 
> +++++++++
> 
> Of course not.  I know Po Lu will not disappoint me.
> 
> I shall presevere in the face of adversity.
> 
> +++++++++
> 
> I stayed up late.
> 
> I read the fine manual.
> 
> I downloaded and installed Noto Sans Mono CJK SC TTF fonts.
> 
> I enabled (modifier-bar) mode.
> 
> I adapted my key-chord-based approach.
> I defined my own menu for Org Agenda commands with (easy-menu-define).
> 
> I searched the mailing list archives.
> 
> I discovered (touch-screen-display-keyboard).  Which makes the
> on-screen keyboard always available.
> 
> I discovered (overriding-text-conversion-style nil).  Which makes
> Emacs-based input methods, of which I use pyim and german-prefix,
> usable.
> 
> I documented them at https://www.emacswiki.org/emacs/EmacsOnAndroid
> 
> It might be an illusion, but the CJK glyphs have never been so
> aesthetically pleasing as they now appears on the smartphone screen.
> 
> Once again, the Emacs developers and Po Lu changed my computing life.
> 
> +++++++++
> 
> Yearly, untold millions and billions have been devoted to the
> marketing, and manufacture of locked-down devices known as Android
> smartphones and tablets.
> 
> LineageOS partially freed some of them from the tyranny of the
> manufacturers.
> 
> F-Droid, Termux and Emacs, together, transformed the platform into
> something usable for general computing.
> 
> Therefore, in this moment, I want to thank Po Lu for their tireless
> effort of developing Emacs in general, and bringing Emacs to the
> Android platform in particular.  Thank you.

Sending it as a bug report might not be the best idea. But commendable spirit; happy hacking :-)

Yuan